## START: Set by rpmautospec
## (rpmautospec version 0.6.1)
## RPMAUTOSPEC: autorelease, autochangelog
%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
    release_number = 2;
    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
    print(release_number + base_release_number - 1);
}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
## END: Set by rpmautospec

%bcond_with check
%global python3_pkgversion 3.11
%global pypi_name maturin
%global pypi_version %(echo %{version} | tr -d "~")

Name:           %{?scl_prefix}python-%{pypi_name}
Version:        1.4.0
Release:        %autorelease
Summary:        Build and publish Rust crates as Python packages
License:        0BSD AND Apache-2.0 AND Apache-2.0 WITH LLVM-exception AND BSD-3-Clause AND MIT AND MPL-2.0 AND Unicode-DFS-2016 AND (0BSD OR MIT OR Apache-2.0) AND (Apache-2.0 OR BSD-2-Clause) AND (Apache-2.0 OR BSL-1.0) AND (Apache-2.0 OR MIT) AND (Apache-2.0 WITH LLVM-exception OR Apache-2.0 OR MIT) AND (BSD-2-Clause OR Apache-2.0 OR MIT) AND (CC0-1.0 OR MIT-0 OR Apache-2.0) AND (MIT OR Apache-2.0 OR Zlib) AND (Unlicense OR MIT)
# LICENSE.dependencies contains a full license breakdown

URL:            https://github.com/PyO3/maturin
Source0:        %{pypi_source}
# To create the vendor tarball:
#   tar xf %%{name}-%%{version}.tar.gz ; pushd %%{name}-%%{version} ; \
#   patch -p1 < ../0001-disable-unavailable-features-and-drop-unused-test-de.patch && \
#   cargo vendor --versioned-dirs && tar Jcvf ../%%{name}-%%{version}-vendor.tar.xz vendor/ ; popd
Source1:        %{pypi_name}-%{version}-vendor.tar.xz

Patch0:          0001-drop-unavailable-features-and-unused-dev-dependencie.patch
Patch1:          0002-drop-incompatible-cargo-flags-from-setuptools_rust.patch
Patch2:          0003-remove-shebang-from-non-executable-__init__.py-file.patch

%if %{defined rhel}
BuildRequires:  rust-toolset
%else
BuildRequires:  cargo-rpm-macros >= 24
%endif
BuildRequires:  python%{python3_pkgversion}
BuildRequires:  python%{python3_pkgversion}-devel
BuildRequires:  python%{python3_pkgversion}-rpm-macros
BuildRequires:  python%{python3_pkgversion}-pip
BuildRequires:  python%{python3_pkgversion}-wheel
BuildRequires:  python%{python3_pkgversion}-setuptools
BuildRequires:  python%{python3_pkgversion}-setuptools-rust
BuildRequires:  pyproject-rpm-macros


%{?python_provide:%python_provide python%{python3_pkgversion}-%{pypi_name}}
%description
Build and publish crates with pyo3, rust-cpython and cffi bindings as
well as rust binaries as python packages.

%prep
%autosetup -n %{pypi_name}-%{pypi_version} -p1 %{?rhel:-a1}
%cargo_prep %{?rhel:-v vendor}

%build
export RUSTFLAGS="%{build_rustflags}"
%pyproject_wheel

%{cargo_license_summary}
%{cargo_license} > LICENSE.dependencies
%if %{defined rhel}
%{cargo_vendor_manifest}
%endif

%install
%pyproject_install
%pyproject_save_files %{pypi_name}

# generate and install shell completions
target/release/%{pypi_name} completions bash > %{pypi_name}.bash
target/release/%{pypi_name} completions fish > %{pypi_name}.fish
target/release/%{pypi_name} completions zsh > _%{pypi_name}

install -Dpm 0644 %{pypi_name}.bash -t %{buildroot}/%{bash_completions_dir}
install -Dpm 0644 %{pypi_name}.fish -t %{buildroot}/%{fish_completions_dir}
install -Dpm 0644 _%{pypi_name} -t %{buildroot}/%{zsh_completions_dir}

%if %{with check}
%check
# * skip a test that fails with Rust 1.74+
# * skip tests for which fixtures are not included in published sources
%cargo_test -- -- --skip build_context::test::test_macosx_deployment_target --skip build_options::test::test_find_bridge --skip metadata::test::test_implicit_readme --skip metadata::test::test_merge_metadata_from_pyproject --skip pyproject_toml::tests::test_warn_missing_maturin_version
%endif

%files -f %{pyproject_files}
%license license-apache
%license license-mit
%license LICENSE.dependencies
%if %{defined rhel}
%license cargo-vendor.txt
%endif
%doc README.md
%doc Changelog.md
%{_bindir}/%{pypi_name}
/%{bash_completions_dir}/%{pypi_name}.bash
/%{fish_completions_dir}/%{pypi_name}.fish
/%{zsh_completions_dir}/_%{pypi_name}

%changelog
## START: Generated by rpmautospec
* Thu Feb 01 2024 Yaakov Selkowitz <yselkowi@redhat.com> - 1.4.0-2
- Update Rust macro usage

* Wed Dec 13 2023 Fabio Valentini <decathorpe@gmail.com> - 1.4.0-1
- Update to version 1.4.0

* Wed Nov 29 2023 Fabio Valentini <decathorpe@gmail.com> - 1.3.2-1
- Update to version 1.3.2

* Mon Nov 13 2023 Yaakov Selkowitz <yselkowi@redhat.com> - 1.2.3-2
- Fix RHEL/ELN build

* Tue Sep 05 2023 Fabio Valentini <decathorpe@gmail.com> - 1.2.3-1
- Update to version 1.2.3; Fixes RHBZ#2229485

* Thu Jul 20 2023 Fedora Release Engineering <releng@fedoraproject.org> - 1.1.0-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_39_Mass_Rebuild

* Sat Jun 24 2023 Python Maint <python-maint@redhat.com> - 1.1.0-2
- Rebuilt for Python 3.12

* Sat Jun 24 2023 Fabio Valentini <decathorpe@gmail.com> - 1.1.0-1
- Update to version 1.1.0; Fixes RHBZ#2214007

* Wed Jun 14 2023 Python Maint <python-maint@redhat.com> - 1.0.1-3
- Rebuilt for Python 3.12

* Wed Jun 07 2023 Fabio Valentini <decathorpe@gmail.com> - 1.0.1-2
- Enable log and scaffolding features

* Mon May 29 2023 Fabio Valentini <decathorpe@gmail.com> - 1.0.1-1
- Update to version 1.0.1; Fixes RHBZ#2210549

* Tue May 23 2023 Fabio Valentini <decathorpe@gmail.com> - 1.0.0-1
- Update to version 1.0.0

* Tue May 23 2023 Fabio Valentini <decathorpe@gmail.com> - 1.0.0~b9-1
- Update to version 1.0.0b9

* Thu May 18 2023 Fabio Valentini <decathorpe@gmail.com> - 1.0.0~b7-1
- Initial import (#2187698)
## END: Generated by rpmautospec
